﻿Public Class Form1
    Dim LCD_Cleared As Boolean
    Private Declare Function OpenDevice Lib "edu05d.dll" () As Integer
    Private Declare Sub CloseDevice Lib "edu05d.dll" ()
    Private Declare Function Connected Lib "edu05d.dll" () As Boolean
    Private Declare Function ReadAnalogChannel Lib "edu05d.dll" (ByVal Channel As Integer) As Integer
    Private Declare Function ReadAllDigital Lib "edu05d.dll" () As Integer
    Private Declare Sub SetPWM Lib "edu05d.dll" (ByVal Channel As Integer, ByVal Data As Integer)
    Private Declare Sub InOutMode Lib "edu05d.dll" (ByVal IOMode As Integer)
    Private Declare Sub OutputAllDigital Lib "edu05d.dll" (ByVal Data As Integer)
    Private Declare Sub ClearAllDigital Lib "edu05d.dll" ()
    Private Declare Sub SetAllDigital Lib "edu05d.dll" ()
    Private Declare Sub ClearDigitalChannel Lib "edu05d.dll" (ByVal Channel As Integer)
    Private Declare Sub SetDigitalChannel Lib "edu05d.dll" (ByVal Channel As Integer)
    Private Declare Sub LCDInit Lib "edu05d.dll" ()
    Private Declare Sub LCDClear Lib "edu05d.dll" ()
    Private Declare Sub LCDWriteString Lib "edu05d.dll" (ByVal Data As String, ByVal Position As Integer)

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim h As Integer
        h = OpenDevice()

        Select Case h
            Case 0
                Label1.Text = "EDU05 not found"
            Case 1
                Label1.Text = "EDU05 connected"

                Timer1.Enabled = True
        End Select
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim i As Integer
        Dim Buffer(5) As Integer
        Timer1.Enabled = False

        If Connected() Then
            Label1.Text = "EDU05 connected"
        Else
            Label1.Text = "EDU05 not connected"
        End If

        InOutMode(1)        ' input mode
        For i = 0 To 4
            Buffer(i) = ReadAnalogChannel(i + 1)
        Next
        i = ReadAllDigital()
        InOutMode(0)        ' output mode

        Select Case i

            Case 1
                textBox1.Text = "Button = SW1    "
                SetDigitalChannel(1)
                panel1.BackColor = Color.FromArgb(255, 128, 0)
            Case 2
                textBox1.Text = "Button = SW2    "
                SetDigitalChannel(2)
                panel2.BackColor = Color.FromArgb(255, 128, 0)
            Case 4
                textBox1.Text = "RV1 = " + Convert.ToInt32(Buffer(0) * 100 / 1023).ToString() + "% "
                SetDigitalChannel(3)
                panel3.BackColor = Color.FromArgb(255, 128, 0)
            Case 8
                textBox1.Text = "RV2 = " + Convert.ToInt32(Buffer(1) * 100 / 1023).ToString() + "% "
                SetDigitalChannel(4)
                panel4.BackColor = Color.FromArgb(255, 128, 0)
            Case 16
                textBox1.Text = "Temp. = " + Convert.ToInt32((Buffer(2) - 155) * 10 / 31).ToString() + "°C "
                SetDigitalChannel(5)
                panel5.BackColor = Color.FromArgb(255, 128, 0)
            Case 32
                If (Buffer(3) > 0) Then
                    textBox1.Text = "NTC = " + Convert.ToInt32((1023 - Buffer(3)) * 10000 / Buffer(3)).ToString() + "ohm "
                End If
                SetDigitalChannel(6)
                panel6.BackColor = Color.FromArgb(255, 128, 0)
            Case 64
                If (Buffer(4) > 0) Then
                    textBox1.Text = "LDR = " + Convert.ToInt32((1023 - Buffer(4)) * 10000 / Buffer(4)).ToString() + "ohm "
                End If
                SetDigitalChannel(7)
                panel7.BackColor = Color.FromArgb(255, 128, 0)
            Case 128
                textBox1.Text = "Button = SW8    "
                SetDigitalChannel(8)
                panel8.BackColor = Color.FromArgb(255, 128, 0)
            Case Else
                textBox1.Text = ""
                ClearAllDigital()
                panel1.BackColor = Color.LightGray
                panel2.BackColor = Color.LightGray
                panel3.BackColor = Color.LightGray
                panel4.BackColor = Color.LightGray
                panel5.BackColor = Color.LightGray
                panel6.BackColor = Color.LightGray
                panel7.BackColor = Color.LightGray
                panel8.BackColor = Color.LightGray
        End Select

        If (textBox1.Text = "") Then
            If (Not LCD_Cleared) Then
                LCDClear()
                LCD_Cleared = True
            End If
        Else
            LCDWriteString(textBox1.Text, 0)
            LCD_Cleared = False
        End If

        Timer1.Enabled = True
    End Sub

    Private Sub button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button6.Click
        CloseDevice()
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        CloseDevice()
    End Sub

End Class
